﻿#Region "FileHeader"
#If False Then
WeakAttachBase ist zu beerben und mit beliebigen Daten-Feldern und whatever zu erweitern. Wichtigste Vererbung ist dann die Shared Get - Methode, mit der ein Attachment von beliebigen Objekten abgerufen werden kann.
Das Attachment ist selbst-Instanzierend, sodass wirklich jedem Objekt die zusätzlichen Felder zur Verfügung stehen. Es können sogar Initialisierungen durchgeführt werden, wenn der Erbe in seiner Shared Sub New den _Creater-Delegaten durch eine eigene Logik ersetzt.
#End If '-- Options, Imports
#End Region 'FileHeader

Namespace System.Runtime.CompilerServices

   ''' <summary> Erben dieser Klasse sind mit beliebigen Daten-Feldern und whatever zu erweitern. Wichtigste Vererbung ist die Shared Get - Methode, mit der ein Attachment (selbstinstanzierend) von beliebigen Objekten abgerufen werden kann. </summary>
   Public MustInherit Class WeakAttachBase(Of Tself As {WeakAttachBase(Of Tself), New})

      Protected Shared _Creater As ConditionalWeakTable(Of Object, Tself).CreateValueCallback
      Public Shared ReadOnly Attachs As ConditionalWeakTable(Of Object, Tself) = New ConditionalWeakTable(Of Object, Tself)

      Shared Sub New()
         Dim dummy = New Tself 'Bug: Nur Instanzieren eines Dummies erzwingt zuverlässig den Aufruf von Shared Sub New() erbender Klassen. Ist nötig, damit dort ggfs ein _Creater gesetzt wern kann
         If _Creater Is Nothing Then _Creater = Function(k) New Tself
      End Sub

      ''' <summary>gibt das dem key zugeordnete Attachment zurück - ist noch keines zugeordnet, wirds erstellt </summary>
      Public Shared Function [Get](key As Object) As Tself
         Return Attachs.GetValue(key, _Creater)
      End Function

      ''' <summary>setzt value auf das dem key zugeordnete Attachment zurück - ist noch keines zugeordnet, wirds erstellt und returnt zusätzlich True </summary>
      Public Shared Function CreateIfMissing(key As Object, ByRef value As Tself) As Boolean
         CreateIfMissing = Not Attachs.TryGetValue(key, value)
         If CreateIfMissing Then
            value = _Creater(key)
            Attachs.Add(key, value)
         End If
      End Function
      Public Shared Function Exists(key As Object) As Boolean
         Dim value As Tself = Nothing
         Return Attachs.TryGetValue(key, value)
      End Function
   End Class

   ''' <summary> Dieses Attach kann nur an TKey attached werden, und hält ausserdem einen Verweis auf den Key, an den es attached ist </summary>
   Public MustInherit Class WeakAttacCoupled(Of TKey As Class, Tself As {WeakAttacCoupled(Of TKey, Tself), New})

      Private Shared ReadOnly _IListFields As New ConditionalWeakTable(Of TKey, Tself)

      Protected Shared _Creater As ConditionalWeakTable(Of TKey, Tself).CreateValueCallback = _
         Function(k) New Tself With {._Key = k}

      Protected _Key As TKey

      Public Shared Function GetAttached(key As TKey) As Tself
         Return _IListFields.GetValue(key, _Creater)
      End Function

   End Class

End Namespace
